package Luokat;

import java.io.PrintStream;
import java.time.LocalDate;
import java.time.format.DateTimeFormatter;
import java.time.format.DateTimeParseException;
import java.util.ArrayList;
import java.util.List;

/**
 * Luokka yhden reissun esittämistä varten osaa muodostaa reissun joko suoraan tiedoston tiedoista tai attribuuteista
 * osaa myös muuttaa reissun tiedot tallennus muotoon
 */
public class Reissu {
private LocalDate Pvm;
private static int SeuraavanReissunTag = 1;
private int reissunTag;
private String sijainti;
private String keli;
private List<Saalis> saaliit;
private boolean poistetaanko;

	public Reissu(LocalDate Pvm, String sijainti, String keli, List<Saalis> saaliit, boolean poistetaanko) {
		this.Pvm = Pvm;
		this.reissunTag = SeuraavanReissunTag;
        SeuraavanReissunTag++;
		this.sijainti = sijainti;
		this.keli = keli;
		this.saaliit = saaliit;
		this.poistetaanko = false;
	}

	
    public int getTag() {
        return reissunTag;
    }

    public LocalDate getPaivamaara() {
        return this.Pvm;
    }
    public String getPvmString() {
    	 DateTimeFormatter date = DateTimeFormatter.ofPattern("dd-MM-yyyy");
    	    return Pvm.format(date);
    }
    public String getSijainti() {
        return sijainti;
    }
    public List<Saalis> getSaaliit() {
        return saaliit;
    }
    public String getKeli() {
        return keli;
    }
    public boolean getpoistetaanko() {
        return poistetaanko;
    }
    public void poistetaan() {
    	poistetaanko = true;
    	
    }

    
    public static LocalDate sToDate(String pvm) {
    	DateTimeFormatter paivamaara = DateTimeFormatter.ofPattern("dd-MM-yyyy");
    	pvm = pvm.replace('.', '-').replace(' ', '-').replace(',', '-');
    	
    	String[] osat = pvm.split("-");
    	if (osat.length == 3) {
    	    if (osat[0].length() == 1) osat[0] = "0" + osat[0];
    	    if (osat[1].length() == 1) osat[1] = "0" + osat[1];
    	    pvm = osat[0] + "-" + osat[1] + "-" + osat[2];
    	}
    	
    	if (onkoValid(pvm, paivamaara )) {
    		  System.out.println("Päivämäärä kelpaa: " + LocalDate.parse(pvm, paivamaara));
            return LocalDate.parse(pvm, paivamaara);
          
        } else {
            System.out.println("Virheellinen päivämäärämuoto!");
            return null;
        }
    }

    public static boolean onkoValid(String dateStr, DateTimeFormatter formatter) {
        try {
            LocalDate.parse(dateStr, formatter);
            return true;
        } catch (DateTimeParseException e) {
            return false;
        }
    }
    
    public Reissu (String tiedosto) {
    	String[] t = tiedosto.split("\\|"); 
    	this.Pvm = sToDate(t[1]);
    	this.sijainti = t[2];
    	this.keli = t[3];
        int tagi = Integer.parseInt(t[0]);
    	this.reissunTag = tagi;
        SeuraavanReissunTag = tagi+1;
        this.poistetaanko = false;
    }
    public void setSaaliit(List<Saalis> saaliit) {
    	this.saaliit = saaliit;
    }
    
    public String toString() {
    	String tag = Integer.toString(reissunTag);
        String pvm = Pvm.format(DateTimeFormatter.ofPattern("dd-MM-yyyy")).replace('-', '.');
    	 return  tag + "|" + pvm + "|" + sijainti + "|" + keli;
    }
   
    
    //helppo testi
    public static void main(String[] args) {
    	
    	Reissu testi = new Reissu( sToDate("01.12.2025"), "Jyväskylä", "lumisade", new ArrayList<>(), false);
        System.out.println(testi);
    	LocalDate date = LocalDate.parse("01-12-2025", DateTimeFormatter.ofPattern("dd-MM-yyyy"));
        LocalDate nyt = LocalDate.now();
        if (nyt.isBefore(date)) {
            System.out.println(nyt + " on myöhemmin kuin " + date);
        }


    }
}

